Subject: bug#7394: rename() over NFS

From: Bruno Haible <[email-masked]>
Date: Sun, 14 Nov 2010 00:58:21 +0100

Eric Blake wrote:
> For now, I'm okay with weakening the testsuite to ignore the NFS bug;
> please apply this patch, but let's also document the bug.

OK. Done like this:

2010-11-13  Bruno Haible  <[email-masked]>

	rename, renameat: Document Linux bug with NFS
	<http://lists.gnu.org/archive/html/bug-gnulib/2010-11/msg00154.html>.
	* doc/posix-functions/rename.texi: Mention the NFS bug on Linux.
	* doc/posix-functions/renameat.texi: Likewise.
	Suggested by Eric Blake.

--- doc/posix-functions/rename.texi.orig	Sun Nov 14 00:55:19 2010
+++ doc/posix-functions/rename.texi	Sun Nov 14 00:50:58 2010
@@ -60,6 +60,11 @@
 @code{ENOTDIR} if either argument is a symlink with a trailing slash:
 glibc, OpenBSD, Cygwin 1.7.
 @item
+After renaming a non-empty directory over an existing empty directory,
+the old directory name is still visible through the @code{stat} function
+for 30 seconds after the rename, on NFS file systems, on some platforms:
+Linux 2.6.18.
+@item
 This function will not rename a source that is currently opened
 by any process:
 mingw.
--- doc/posix-functions/renameat.texi.orig	Sun Nov 14 00:55:19 2010
+++ doc/posix-functions/renameat.texi	Sun Nov 14 00:52:06 2010
@@ -39,6 +39,11 @@
 @code{ENOTDIR} if either argument is a symlink with a trailing slash:
 glibc, OpenBSD, Cygwin 1.7.
 @item
+After renaming a non-empty directory over an existing empty directory,
+the old directory name is still visible through the @code{stat} function
+for 30 seconds after the rename, on NFS file systems, on some platforms:
+Linux 2.6.18.
+@item
 This function will not rename a source that is currently opened
 by any process:
 mingw.